## $Id: utils.py 12032 2014-11-21 18:52:43Z henrik $
##
## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""General helper functions and utilities for the customer section.
"""
import grok
from waeup.ikoba.interfaces import MessageFactory as _
from waeup.ikoba.interfaces import CREATED, STARTED, REQUESTED, APPROVED
from waeup.ikoba.customers.interfaces import ICustomersUtils


def generate_customer_id():
    customers = grok.getSite()['customers']
    new_id = customers.unique_customer_id
    return new_id


class CustomersUtils(grok.GlobalUtility):
    """A collection of methods subject to customization.
    """
    grok.implements(ICustomersUtils)

    #: A prefix used when generating new customer ids. Each customer id will
    #: start with this string. The default is 'K'.
    CUSTOMER_ID_PREFIX = u'K'

    CUSTMANAGE_STATES = (STARTED,)

    DOCMANAGE_STATES = (APPROVED,)

    TRANSLATED_STATES = {
        CREATED: _('created'),
        STARTED: _('started'),
        REQUESTED: _('requested'),
        APPROVED: _('approved'),
        }
